// Small example showing non-portable printing of thread IDs which are
// often just unsigned long
// 
// COMPILE:
// > gcc pthread_ids.c -lpthread
#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

void *doit(void *param){
  pthread_t tid = pthread_self();
  printf("doit: I am thread %ld in pid %d\n",tid,getpid());
  int *var = (int *) param;
  *var = (*var) * 2;
  return NULL;
}

int main(){
  pthread_t thread_1;
  int stackvar = 42;
  pthread_create(&thread_1, NULL, doit, &stackvar);
  pthread_t tid = pthread_self();
  printf("main: I am thread %ld in pid %d\n",tid,getpid());
  pthread_join(thread_1, NULL);
  printf("stack var is: %d\n",stackvar);
  return 0;
}
